{*****************************************************************}
{                                                                 }
{             ScriptReporter 2.1 example unit                     }
{                                                                 }
{  Function                 CONCAT(Str1, Str2)                    }
{  --------                                                       }
{  Call from script example  Result := Concat('My ', 'function'); }
{  ------------------------                                       }
{                                                                 }
{  Author: Vlad Ilushchenko                                       }
{                                                                 }
{*****************************************************************}

unit ExSet;

interface

uses Reporter, RepExpr, RepKrnl;

type
  TSetExample = class(TRepSetExpression)
  protected
    function GetAsVariant: Variant; override;
    function DefFunction(var AName: string): Integer; override;
  end;

implementation

function TSetExample.DefFunction(var AName: String): Integer;
begin
  AName  := 'CONCAT'; // function name for error message
  Result := 2;        // number of arguments;
end;

function TSetExample.GetAsVariant: Variant;
var
  S1, S2: String;
begin
  S1 := Values[0]; // value of the first argument
  S2 := Values[1]; // value of the second argument
  Result := S1 + S2;
end;

initialization

  AddPlugIn('CONCAT', [akRight, akSet], TSetExample, False);
//           ^        ^                 ^            ^
//           |        |                 |            will not treated as separate token
//           |        |                 class reference
//           |        argument decription
//           plug-in name

end.

