{************************************************************}
{                                                            }
{             ScriptReporter 2.1 example unit                }
{                                                            }
{  Function                 SQRT(Argument)                   }
{  --------                                                  }
{  Call from script example  Result := SQRT(4);              }
{  ------------------------                                  }
{                                                            }
{  Author: Vlad Ilushchenko                                  }
{                                                            }
{************************************************************}

unit ExUnary;

interface

uses Reporter, RepExpr, RepKrnl;

type
  TUnaryExample = class(TRepUnaryExpression)
  protected
    function GetAsVariant: Variant; override;
  end;

implementation

function TUnaryExample.GetAsVariant: Variant;
begin
  Result := Sqrt(Arg.Addr.Value);
end;

initialization

  AddPlugIn('SQRT', [akRight], TUnaryExample, False);
//           ^       ^         ^              ^
//           |       |         |              will not treated as separate token
//           |       |         class reference
//           |       argument decription
//           plug-in name
end.
