{**
*
*         Script Reporter Component library
*          Vlad Ilushchenko 1998-99
*
*
**}

unit ObjList;

interface

uses Classes;

type
  TObjectList = class(TList)
  protected
    procedure FreeItems; virtual;
  public
    destructor Destroy; override;
    procedure ClearObjects;
    procedure Delete(Index: Integer);
    procedure SafeDelete(Index: Integer);
  end;

function Max(Val1, Val2: Integer): Integer;
function Min(Val1, Val2: Integer): Integer;

implementation

function Max(Val1, Val2: Integer): Integer; assembler;
asm
  cmp EAX, EDX
  jg  @@1
  mov EAX, EDX
@@1:
end;

function Min(Val1, Val2: Integer): Integer; assembler;
asm
  cmp EAX, EDX
  jl  @@1
  mov EAX, EDX
@@1:
end;


{TObjectList}

destructor TObjectList.Destroy;
begin
  FreeItems;
  Clear;
end;

procedure TObjectList.ClearObjects;
begin
  FreeItems;
  Clear;
end;

procedure TObjectList.Delete(Index: Integer);
begin
  if Items[Index] <> nil then
    TObject(Items[Index]).Free;
  inherited Delete(Index);
end;

procedure TObjectList.FreeItems;
var
  i: Integer;
begin
  for i:=0 to Count-1 do
    if Items[i] <> nil then
      TObject(Items[i]).Free;
end;

procedure TObjectList.SafeDelete(Index: Integer);
begin
  inherited Delete(Index);
end;

end.
