{**
*
*         Script Reporter Component library
*         Additional string routines
*          Vlad Ilushchenko 1998-99
*
*
**}

unit StringTools;

interface

function Padl(Value: AnsiString; aLength: Integer): AnsiString;
function Padr(Value: AnsiString; aLength: Integer): AnsiString;
function Space(Count: Integer): String;
function ReplicateChar(Value: Char;Count: integer): String;
function CenterStr(S: AnsiString; Len: Integer): AnsiString;

implementation

type
  StrRec = record
    allocSiz: Longint;
    refCnt:   Longint;
    length:   Longint;
  end;

const
  skew = sizeof(StrRec);

function ReplicateChar(Value: Char; Count: Integer): AnsiString; assembler;
asm
  {
    EAX -> char
    EDX -> count
    ECX -> poiter to result
  }
  TEST  EDX, EDX
  JG    @@Normal
  XOR   EDX, EDX
@@Normal:
  PUSH  EAX
  PUSH  ECX
  PUSH  EDX
  PUSH  EDI


  PUSH  ECX
  PUSH  EAX

  MOV   EAX, EDX
  CALL  System.@NewAnsiString
  MOV   EDI, EAX

  POP   EAX
  PUSH  EDI

  MOV   ECX, EDX
  REPNZ STOSB

  POP   EDX
  POP   EAX
  CALL  SYSTEM.@LSTRASG

  POP   EDI
  POP   EDX
  POP   ECX
  POP   EAX
end;

function Padl(Value: AnsiString; ALength: Integer): AnsiString; assembler;
asm
  {
    EAX -> pointer to Value
    EDX -> new length
    ECX -> pointer to Result
  }
  TEST  EAX, EAX
  JZ    @@Exit
  PUSH  EAX
  PUSH  EBX
  PUSH  ECX
  PUSH  EDX
  PUSH  ESI
  PUSH  EDI
  PUSH  EBP

  MOV   EBP, [EAX-skew].StrRec.Length
  CMP   EDX, EBP
  JGE   @@Normal
  MOV   EBP, EDX
@@Normal:
  MOV   ESI, EAX
  MOV   EAX, EDX
  PUSH  ECX
  CALL  System.@NewAnsiString
  POP   ECX

  PUSH  EAX
  MOV   EDI, EAX
  MOV   EBX, ECX

  MOV   ECX, EDX
  SUB   ECX, EBP
  MOV   EAX, ' '
  REPNZ STOSB

  MOV   ECX, EBP
  REPNZ MOVSB

  POP   EDX
  MOV   EAX, EBX
  CALL  System.@LStrAsg

  POP   EBP
  POP   EDI
  POP   ESI
  POP   EDX
  POP   ECX
  POP   EBX
  POP   EAX
@@Exit:
end;

function Padr(Value: AnsiString; ALength: Integer): AnsiString; assembler;
asm
  {
    EAX -> pointer to Value
    EDX -> new length
    ECX -> pointer to Result
  }
  TEST  EAX, EAX
  JZ    @@Exit
  PUSH  EAX
  PUSH  EBX
  PUSH  ECX
  PUSH  EDX
  PUSH  ESI
  PUSH  EDI
  PUSH  EBP

  MOV   EBP, [EAX-skew].StrRec.Length
  CMP   EDX, EBP
  JGE   @@Normal
  MOV   EBP, EDX
@@Normal:
  MOV   ESI, EAX  {ESI -> source}
  MOV   EAX, EDX
  PUSH  ECX
  CALL  System.@NewAnsiString
  POP   ECX

  PUSH  EAX
  MOV   EDI, EAX
  MOV   EBX, ECX

  MOV   ECX, EBP
  REPNZ MOVSB

  MOV   ECX, EDX
  SUB   ECX, EBP
  MOV   EAX, ' '
  REPNZ STOSB

  POP   EDX
  MOV   EAX, EBX
  CALL  System.@LStrAsg

  POP   EBP
  POP   EDI
  POP   ESI
  POP   EDX
  POP   ECX
  POP   EBX
  POP   EAX
@@Exit:
end;

function Space(Count: Integer): String;
begin
  Result := ReplicateChar(' ', Count);
end;

function CenterStr(S: AnsiString; Len: Integer): AnsiString; assembler;
asm
  {
    EAX -> pointer to Value
    EDX -> new length
    ECX -> pointer to Result
  }
  TEST  EAX, EAX
  JZ    @@Exit
  PUSH  EAX
  PUSH  EBX
  PUSH  ECX
  PUSH  EDX
  PUSH  ESI
  PUSH  EDI

  CMP   EDX, [EAX-skew].StrRec.Length
  JG    @@Normal
  MOV   EDX, [EAX-skew].StrRec.Length
@@Normal:
  MOV   ESI, EAX
  MOV   EAX, EDX
  PUSH  ECX
  CALL  System.@NewAnsiString
  POP   ECX

  PUSH  EAX
  MOV   EDI, EAX
  MOV   EBX, ECX

  MOV   ECX, EDX
  SUB   ECX, [ESI-skew].StrRec.Length
  SHR   ECX, 1
  PUSH  ECX
  MOV   EAX, ' '
  REPNZ STOSB

  PUSH  ESI
  MOV   ECX, [ESI-skew].StrRec.Length
  REPNZ MOVSB
  POP   ESI

  POP   EAX
  MOV   ECX, EDX
  SUB   ECX, [ESI-skew].StrRec.Length
  SUB   ECX, EAX
  MOV   EAX, ' '
  REPNZ STOSB

  POP   EDX
  MOV   EAX, EBX
  CALL  System.@LStrAsg

  POP   EDI
  POP   ESI
  POP   EDX
  POP   ECX
  POP   EBX
  POP   EAX
@@Exit:
end;

end.
